//
//  YMNavigationBar.h

#import <UIKit/UIKit.h>
#import "YMBarButtonItem.h"
#import "YMBarItemView.h"

NS_ASSUME_NONNULL_BEGIN

@interface YMNavigationBar : UIView


@property (nonatomic, strong) YMBarItemView *leftBarButtonItemView;

@property (nonatomic, strong) YMBarItemView *rightBarButtonItemView;

@property (nonatomic, strong) YMBarItemView *titleItemView;


/**
 *  @brief 标题数据项，支持文字/图片的高度自定制，默认优先使用图片
 */
@property(nullable,nonatomic,strong) YMBarItem *titleItem;

/**
 *  @brief 左按钮数据项，支持Plain、Back、Custome样式
 */
@property(nullable,nonatomic,strong) YMBarButtonItem *leftBarButtonItem;

/**
 *  @brief 右按钮数据项，支持Plain、Custome样式
 */
@property(nullable,nonatomic,strong) YMBarButtonItem *rightBarButtonItem;

/**
 *  @brief 右按钮数据项，支持Plain、Custome样式
 */
@property(nullable,nonatomic,strong) YMBarButtonItem *leftQuitButtonItem;

/**
 *  @brief 背景图片
 */
@property(nullable,nonatomic,strong) UIImage *backgroundImage;

/**
 *  @brief 分割线宽度，默认1 pixel:1/[[UIScreen mainScreen] scale]
 */
@property(nonatomic,assign) CGFloat separatorHeight;

/**
 *  @brief 分割线颜色，默认[UIColor clearColor]
 */
@property(nullable, nonatomic,strong) UIColor *separatorColor;

/**
 *  @brief 是否隐藏返回按钮
 */
@property(nonatomic,assign) BOOL hidesBackButton;

/**
 导航条上部预留间隔

 @return 高度
 */
+ (CGFloat)navigationBarTopInterval;


@end

NS_ASSUME_NONNULL_END
