

#import <Foundation/Foundation.h>
#import "SLBaseMainView.h"
#import "SLPageModel.h"

NS_ASSUME_NONNULL_BEGIN

@interface SLPageViewModel : NSObject

@property (nonatomic, strong) SLPageModel *pageModel;

@property (nonatomic, copy) Class cellClass;

@property (nonatomic, assign) CGSize viewSize;

@property (nonatomic, assign) CGSize headerSize;

- (instancetype)initWith:(SLPageModel *)pageModel cellClass:(nullable Class)cellClass viewSize:(CGSize)viewSize headerSize:(CGSize)headerSize;

///  我的模型
+ (NSMutableArray<SLPageViewModel *> *)myPageViewModels;

///  用户中心模型
+ (NSMutableArray<SLPageViewModel *> *)userCenterPageViewModels;

///  首页模型
+ (NSMutableArray<SLPageViewModel *> *)homePageViewModelsWith:(NSArray *)chatList;

///  练习模型
+ (NSMutableArray<SLPageViewModel *> *)lxPageViewModels;

@end

NS_ASSUME_NONNULL_END
